/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DESPERCIA                                                */
/* Tabela : DESPERCIA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DESPERCIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_DESPERCIA
GO

CREATE TRIGGER DTULTATU_DESPERCIA
ON DESPERCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DESPERCIA', null, 'CDCIA='+ CDCIA+ ';'+
                                        'CDFILIAL='+ CDFILIAL+ ';'+
                                        'DTINIDESC='+ CONVERT(CHAR,DTINIDESC,120)+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DESPERCIA
      SET DTULTATUDCIA = GETDATE()
      FROM INSERTED;
   END;
END;
GO

