/*
Sistemas Integrados TEKNISA
Nome: 3884_VNDTRGS_TRIGGER_MOVPONTOCONS.SQL
Descrio: Atualiza o saldo de pontos do consumidor na tabela SALDOCONSCAMP
Criao: 26/11/2012 Andreza Valgas
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'SALDO_MOVPONTOCONS'
              AND TYPE   = 'TR'
              AND U.UID  = O.UID
              AND U.NAME = USER)
   DROP TRIGGER SALDO_MOVPONTOCONS
   GO

CREATE TRIGGER SALDO_MOVPONTOCONS
ON MOVPONTOCONS
FOR INSERT, DELETE
AS

DECLARE @V_NRDADOS             INTEGER;
DECLARE @V_VRMOVPONTOCONS_AUX  FLOAT;
DECLARE @V_CDCAMPANHA          VARCHAR(10);
DECLARE @V_CDCLIENTE           VARCHAR(21);
DECLARE @V_CDCONSUMIDOR        VARCHAR(21);
DECLARE @V_IDTPMOVCONS         VARCHAR(1);
DECLARE @V_VRMOVPONTOCONS      FLOAT;

BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      SELECT @V_CDCAMPANHA     = DELETED.CDCAMPANHA,
             @V_CDCLIENTE      = DELETED.CDCLIENTE,
             @V_CDCONSUMIDOR   = DELETED.CDCONSUMIDOR,
             @V_IDTPMOVCONS    = DELETED.IDTPMOVCONS,
             @V_VRMOVPONTOCONS = DELETED.VRMOVPONTOCONS
        FROM DELETED;

      IF @V_IDTPMOVCONS = 'C' BEGIN
         SET @V_VRMOVPONTOCONS_AUX = @V_VRMOVPONTOCONS * (-1);
      END ELSE BEGIN
         SET @V_VRMOVPONTOCONS_AUX = @V_VRMOVPONTOCONS;
      END;

      UPDATE SALDOCONSCAMP
         SET VRSALDOCONS = VRSALDOCONS + @V_VRMOVPONTOCONS_AUX
       WHERE CDCAMPANHA   = @V_CDCAMPANHA
         AND CDCLIENTE    = @V_CDCLIENTE
         AND CDCONSUMIDOR = @V_CDCONSUMIDOR;
   END ELSE BEGIN
      SELECT @V_CDCAMPANHA     = INSERTED.CDCAMPANHA,
             @V_CDCLIENTE      = INSERTED.CDCLIENTE,
             @V_CDCONSUMIDOR   = INSERTED.CDCONSUMIDOR,
             @V_IDTPMOVCONS    = INSERTED.IDTPMOVCONS,
             @V_VRMOVPONTOCONS = INSERTED.VRMOVPONTOCONS
        FROM INSERTED;

      SELECT @V_NRDADOS = COUNT(*)
        FROM SALDOCONSCAMP
       WHERE CDCAMPANHA   = @V_CDCAMPANHA
         AND CDCLIENTE    = @V_CDCLIENTE
         AND CDCONSUMIDOR = @V_CDCONSUMIDOR;

      IF @V_IDTPMOVCONS = 'C' BEGIN
         SET @V_VRMOVPONTOCONS_AUX = @V_VRMOVPONTOCONS;
      END ELSE BEGIN
         SET @V_VRMOVPONTOCONS_AUX = @V_VRMOVPONTOCONS * (-1);
      END;

      IF @V_NRDADOS = 0 BEGIN
         INSERT INTO SALDOCONSCAMP
            (CDCAMPANHA, CDCLIENTE, CDCONSUMIDOR, VRSALDOCONS, VRVENDARESTCONS, QTVENDARESTCONS, DTINCLUSAO)
         VALUES
            (@V_CDCAMPANHA, @V_CDCLIENTE, @V_CDCONSUMIDOR, @V_VRMOVPONTOCONS_AUX, 0, 0, GETDATE());
      END ELSE BEGIN
         UPDATE SALDOCONSCAMP
            SET VRSALDOCONS = VRSALDOCONS + @V_VRMOVPONTOCONS_AUX
          WHERE CDCAMPANHA   = @V_CDCAMPANHA
            AND CDCLIENTE    = @V_CDCLIENTE
            AND CDCONSUMIDOR = @V_CDCONSUMIDOR;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'SALDO_MOVPONTOCONS','5.50.000';
GO
